lots of updates
[distro-setup] / distro-begin
1 #!/bin/bash -l
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16
17
18
19 # for bootstrapping a new machine
20
21 # in case we need it,
22 # to make ssh interactive shell run better, we run this first.
23 sudo bash -c 'source /a/c/.bashrc && source /a/exe/ssh-emacs-setup'
24
25
26 # usage: $0 [-r] HOSTNAME
27
28 # tips:
29 # run any sudo command first so your pass is cached
30 # set the scrollback to unlimited in case something goes wrong
31
32 if [[ $EUID == 0 ]]; then
33 if getent passwd ian; then
34 echo "$0: error: running as root. unprivileged user exists. use it."
35 exit 1
36 else
37 echo "$0: warning: running as root. I will setup users then exit"
38 fi
39 fi
40
41 interactive=true # set this to false to force set -x
42 [[ $- == *i* ]] || interactive=false
43
44 if ! $interactive; then
45 set -x
46 set -e -o pipefail
47 fi
48 set -E
49 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
50
51 exec &> >(sudo tee -a /var/log/distro-begin)
52 echo "$0: $(date): starting now)"
53
54 # headless=false # unused atm
55 recompile=false
56 # for copying to a new data fs
57 bootstrapfs=false # old flag, needs new look before using.
58 while [[ $1 == -* ]]; do
59 case $1 in
60 -r) recompile=true; shift ;;
61 esac
62 done
63
64 if [[ $1 ]]; then
65 export HOSTNAME=$1
66 fi
67
68 for f in iank-dev htpc treetowl x2 frodo tp li lj demohost; do
69 eval "$f() { [[ $HOSTNAME == $f ]]; }"
70 done
71 has_p() { treetowl || x2 || frodo || tp || demohost; }
72 has_x() { ! linode; }
73 linode() { lj || li; }
74 has_btrfs() { ! linode; }
75 home_network() { ! linode; }
76 encrypted() { has_p; }
77
78 shopt -s extglob
79 export GLOBIGNORE=*/.:*/..
80 umask 0002
81
82
83 ####### end command line parsing
84
85 PATH="/a/exe:$PATH"
86 sed="sed --follow-symlinks"
87
88 ##### begin setup encryption scripts ######
89 if encrypted; then
90 # I tried making a service which was dependent on reboot.target,
91 # but it happened too late in the shutdown process.
92 sudo dd of=/etc/systemd/system/keyscripton.service <<'EOF'
93 [Unit]
94 Description=Turn on automatic decryption of drives on boot
95 # tried using graphical.target, but it made my display manager restart before rebooting.
96 # generally, I don't think targets order shutdown like they do startup.
97 # So, I did systemd-analyze plot > something.svg, and picked a reliably started
98 # service that happens late in the game.
99 After=ntp.service
100 DefaultDependencies=no
101 # not sure if needed, makes sure we shut down before reboot.target
102 Conflicts=reboot.target
103
104 [Service]
105 Type=oneshot
106 RemainAfterExit=yes
107 ExecStart=/bin/true
108 ExecStop=/a/exe/keyscript-on
109
110 [Install]
111 WantedBy=keyscriptoff.service
112 EOF
113 sudo systemctl daemon-reload # needed if the file was already there
114 sudo systemctl stop keyscripton.service
115 # sudo systemctl start keyscripton.service
116 sudo systemctl enable keyscripton.service
117
118 sudo dd of=/etc/systemd/system/keyscriptoff.service <<'EOF'
119 [Unit]
120 Description=Turn off automatic decryption of drives on boot
121
122 [Service]
123 Type=oneshot
124 ExecStart=/a/exe/keyscript-off
125
126 [Install]
127 WantedBy=multi-user.target
128 EOF
129 sudo systemctl daemon-reload # needed if the file was already there
130 sudo systemctl enable keyscriptoff.service
131 sudo systemctl start keyscriptoff.service
132 fi
133 ##### end setup encryption scripts ######
134
135
136 install-myqueue
137
138 # this script has been designed to be idempotent
139 # todo, it would be nice to cut down on some of the output
140
141
142 for x in /a/bin/errhandle/*-function; do
143 source $x
144 done
145
146
147 set +e
148 $interactive || errcatch
149 set +x
150 source /a/bin/distro-functions/src/identify-distros
151 $interactive || set -x
152
153 if isfedora; then
154 # comment out line disallowing calling sudo in scripts
155 sudo $sed -i 's/^Defaults *requiretty/#\0 # ian commented/' /etc/sudoers
156 # turn on magic sysrq commands for this boot cycle
157 echo 1 > sudo dd of=/proc/sys/kernel/sysrq
158 echo "kernel.sysrq = 1" > /etc/sysctl.d/90-sysrq.conf
159 # selinux is not user friendly. Like, you enable samba, but you haven't run the magic selinux commands so it doesn't work
160 # and you have no idea why.
161 sudo $sed -i 's/^\(SELINUX=\).*/\1disabled/' /etc/selinux/config
162 selinuxenabled && sudo setenforce 0
163 fi
164
165
166 # already ran for pxe installs, but used for vps & updates
167 distro=$(distro-name)
168 case $distro in
169 ubuntu|debian|trisquel)
170 sudo bash -c ". /a/bin/fai/fai-wrapper && /a/bin/fai/fai/config/scripts/GRUB_PC/11-ian"
171 ;;
172 *)
173 sudo bash -c ". /a/bin/fai/fai-wrapper &&
174 /a/bin/fai/fai/config/distro-install-common/end"
175 ;;
176 esac
177
178 if linode; then
179 sudo $sed -i '/^127\.0\.1\.1/d' /etc/hosts
180 echo "127.0.1.1 $HOSTNAME.b8.nz $HOSTNAME" | sudo tee -a /etc/hosts
181 fi
182
183
184 if [[ $EUID == 0 ]]; then
185 echo "$0: running as root. exiting now that users are setup"
186 exit 0
187 fi
188
189
190 #### begin link bashrc for root ######
191 for x in /a/c/{.bashrc,brc,.bash_profile,.profile,.inputrc,path_add_function}; do
192 sudo -i <<EOF
193 PATH="/a/exe:$PATH"
194 lnf $x /root
195 EOF
196 done
197 #### end link bashrc repo for root ######
198 # this needs to be before installing pacserve so we have gpg conf.
199 conflink
200
201 set +x
202 errallow
203 source /etc/profile.d/environment.sh
204 source ~/.bashrc
205 $interactive || errcatch
206 $interactive || set -x
207
208
209 # passwordless sudo
210 tu /etc/sudoers <<'EOF'
211 ian ALL=(ALL) NOPASSWD: ALL
212 Defaults env_keep += SUDOD
213 # makes ubuntu be like debian
214 # https://unix.stackexchange.com/a/91572
215 Defaults always_set_home
216 EOF
217
218
219 # enable magic sysrq keys. debian docs say it is already enabled by default
220 isfedora && tu /etc/sysctl.conf 'kernel.sysrq = 1'
221
222
223 if isdeb; then
224 if isdebian-stable && has_x; then
225 codename=$(debian-codename)
226 s dd of=/etc/apt/sources.list.d/mozilla-iceweasel.list <<EOF
227 deb http://mozilla.debian.net/ $codename-backports firefox-release
228 deb-src http://mozilla.debian.net/ $codename-backports firefox-release
229 EOF
230 p update
231 # take care of mozilla signing errors in previous command
232 pi pkg-mozilla-archive-keyring
233 p update
234 else
235 :
236 # this would change stable to testing, but I set that up already.
237 # It\'s just a no-op if its already testing.
238 # sudo sed -ri 's!^( *[^ #]+ +[^ ]+ +)[[:alpha:]]+(.*)!\1testing\2!' /etc/apt/sources.list
239 p update
240 fi
241 fi
242
243 if isarch; then
244 #https://wiki.archlinux.org/index.php/Arch_User_Repository#Installing_packages
245 sudo pacman -S --noconfirm --needed base-devel jq
246 # pacaur seems to be the best, although it + cower has a few minor bugs,
247 # its design goals seem good, so, going for it.
248
249 aurpi() {
250 for p in "$@"; do
251 tempdir=$(mktemp -d)
252 pushd $tempdir
253 aurex "$p"
254 makepkg -sri --skippgpcheck --noconfirm
255 popd
256 rm -rf $tempdir
257 done
258 }
259 aurpi cower pacaur
260
261 pi pacserve
262
263 x=$(mktemp); /usr/bin/pacman.conf-insert_pacserve >$x
264 sudo dd of=/etc/pacman.conf if=$x; rm $x
265 sudo systemctl enable pacserve.service
266 sudo systemctl start pacserve.service
267
268 # strange error if just installing trash-cli: "pyalpm requires python",
269 # so I see that it requires python2, and installing that manually fixes it.
270 # I didn't see this on earlier installation, main thing which changed was
271 # pacserve, so not sure if it's related.
272 pi python2
273 fi
274
275 pup
276 pi trash-cli
277
278
279 ###### link files ###########
280 # convenient to just do all file linking in one place
281
282 # if it wasn't set already, we could set hostname here
283 #echo treetowl | s dd of=/etc/hostname
284 #s hostname -F /etc/hostname
285 #HOSTNAME=$(hostname)
286
287
288 s lnf -T /a/bin /b
289 s lnf -T /nocow/t /t
290
291 if has_p; then
292 lnf -T /p/News ~/News
293 fi
294
295 s lnf /q/root/.editor-backups /q/root/.undo-tree-history \
296 /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
297
298 rootsshsync
299
300 s lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
301
302 # machine is going away
303 # if [[ $HOSTNAME == htpc ]]; then
304 # lnf -T /i/Videos ~/Downloads
305 # fi
306
307 if has_p; then
308 # for dovecot
309 lnf -T /i/k/mboxes ~/mail
310 fi
311
312
313 # basic needed packages
314 case $(distro-name) in
315 debian)
316 if has_x; then
317 if isdebian-stable; then
318 pi firefox/$codename-backports
319 else
320 # for a while, firefox/unstable did not have
321 # dependencies satisfied by testing packages, and i hit
322 # a conflict, it wanted a newer libfontconfig1, but
323 # emacs build-deps wanted an older one. In this case,
324 # I switch to using firefox-esr. note: They seem
325 # to release a new esr version every 9 months or so.
326 pi firefox/unstable
327 s dd of=/etc/apt/preferences.d/firefox <<'EOF'
328 Package: firefox
329 Pin: release a=unstable
330 Pin-Priority: 500
331 EOF
332 fi
333 fi
334 # for hosts which require nonfree drivers
335 # i previously had extra packages listed here linux-image-amd64
336 # firmware-linux-free linux-headers-amd64, but I
337 # don\'t see any reason why. seems to work in testing without.
338 # remove this note if it continues to work.
339 p=firmware-linux-nonfree
340 if apt-cache show $p &>/dev/null; then
341 pi $p
342 fi
343 ;;&
344 trisquel|ubuntu|debian)
345 if has_x; then
346 if isdebian-testing; then
347 pi xmacro/unstable # has no unstable deps
348 else
349 pi xmacro
350 fi
351 pi gtk-redshift xinput
352 fi
353 ;;&
354 fedora)
355 p -y groupinstall development-tools c-development books admin-tools
356 pi wget man-pages
357 if has_x; then
358 pi redshift-gtk
359 # debian has this package patched to work, upstream is dead
360 # tried using alien, pi alien, alien -r *.deb, rpm -Uhv *.rpm, got this error, so fuck it
361 # file /usr/bin from install of xmacro-0.3pre_20000911-7.x86_64 conflicts with file from package filesystem-3.2-19.fc20.x86_64
362 # http://packages.debian.org/source/sid/xmacro
363 pi patch libXtst-devel
364 cd $(mktemp -d)
365 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911.orig.tar.gz
366 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911-6.diff.gz
367 ex *.gz
368 patch -p0 < xmacro_0.3pre-20000911-6.diff
369 cd xmacro-0.3pre-20000911.orig
370 make
371 sleep 1 # not sure why the following command couldn\'t find, so trying this
372 # no make install target
373 s cp -f xmacroplay xmacrorec xmacrorec2 /usr/local/bin
374 fi
375 ;;&
376 arch)
377 # like apt-cache
378 pi pkgfile
379 s pkgfile --update
380 if has_x; then
381 # libxtst is missing dep https://aur.archlinux.org/packages/xmacro/#news
382 pi xorg-server redshift xorg-xinput libxtst xmacro
383
384 # background:
385 # https://aur.archlinux.org/packages/xkbset/#comment-545419
386 cert=$(mktemp)
387 cat >$cert <<'EOF'
388 -----BEGIN CERTIFICATE-----
389 MIIJADCCB+igAwIBAgIRAIVAhZ0TMbQ5jTm0koI8X6YwDQYJKoZIhvcNAQELBQAw
390 djELMAkGA1UEBhMCVVMxCzAJBgNVBAgTAk1JMRIwEAYDVQQHEwlBbm4gQXJib3Ix
391 EjAQBgNVBAoTCUludGVybmV0MjERMA8GA1UECxMISW5Db21tb24xHzAdBgNVBAMT
392 FkluQ29tbW9uIFJTQSBTZXJ2ZXIgQ0EwHhcNMTUxMjA4MDAwMDAwWhcNMTgxMjA3
393 MjM1OTU5WjCBsTELMAkGA1UEBhMCVVMxDjAMBgNVBBETBTY1MjExMREwDwYDVQQI
394 EwhNaXNzb3VyaTERMA8GA1UEBxMIQ29sdW1iaWExHzAdBgNVBAkTFjExMDAgQ2Fy
395 cmllIEZyYW5ja2UgRHIxHzAdBgNVBAoTFlVuaXZlcnNpdHkgb2YgTWlzc291cmkx
396 CzAJBgNVBAsTAk1VMR0wGwYDVQQDExRmYWN1bHR5Lm1pc3NvdXJpLmVkdTCCASIw
397 DQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAN8Kap8hASpxQeqjHibGsCR1PBkh
398 nW9p5FkuhGpMW/3ko8QfxH0W1Hq2y2DTFUmq17kH3GfT3h9a7HcmUrC3q15PciOB
399 WR3j8u0bDfVppyAZXiHJzYGN7xHiPrZtFEGgwZd28+sW80WXTbGl+zKkmeZguGdH
400 AVGeWJEFK44ctLbpjHWCy+xNuhxJuL4olwPoV7WX9IUhceC0rxYQANhLGOJhbchj
401 Z76MA8dc2K3CZI5m7VqQwl09QSnCfz00afUr88ny9vj1S5k2ADS46gaE9O0lM6EY
402 z/uZvMizXN/4ko+hFBjCSt0Vhxjx0kYDSP15btiwh700ywBEubpvLROmd48CAwEA
403 AaOCBUswggVHMB8GA1UdIwQYMBaAFB4Fo3ePbJbiW4dLprSGrHEADOc4MB0GA1Ud
404 DgQWBBTTNWrSb+V/Ayy0i8W2LExMUisQMzAOBgNVHQ8BAf8EBAMCBaAwDAYDVR0T
405 AQH/BAIwADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUHAwIwZwYDVR0gBGAw
406 XjBSBgwrBgEEAa4jAQQDAQEwQjBABggrBgEFBQcCARY0aHR0cHM6Ly93d3cuaW5j
407 b21tb24ub3JnL2NlcnQvcmVwb3NpdG9yeS9jcHNfc3NsLnBkZjAIBgZngQwBAgIw
408 RAYDVR0fBD0wOzA5oDegNYYzaHR0cDovL2NybC5pbmNvbW1vbi1yc2Eub3JnL0lu
409 Q29tbW9uUlNBU2VydmVyQ0EuY3JsMHUGCCsGAQUFBwEBBGkwZzA+BggrBgEFBQcw
410 AoYyaHR0cDovL2NydC51c2VydHJ1c3QuY29tL0luQ29tbW9uUlNBU2VydmVyQ0Ff
411 Mi5jcnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wggOg
412 BgNVHREEggOXMIIDk4IUZmFjdWx0eS5taXNzb3VyaS5lZHWCGmFkdmlzaW5nLmNv
413 YXMubWlzc291cmkuZWR1ghBhaGEubWlzc291cmkuZWR1ghZhbGwtY3JhZnQubWlz
414 c291cmkuZWR1gh1hbWVyaWNhbmJhc2tldHJ5Lm1pc3NvdXJpLmVkdYIXYW5kcmVh
415 cmlldy5taXNzb3VyaS5lZHWCFWFydGdyYWRzLm1pc3NvdXJpLmVkdYIYYmFja3Vw
416 LmNvYXMubWlzc291cmkuZWR1ghBiaWMubWlzc291cmkuZWR1ghZibG9nLmNvYXMu
417 bWlzc291cmkuZWR1ghVjb3dhbmxhYi5taXNzb3VyaS5lZHWCFWRhZS5zdGF0Lm1p
418 c3NvdXJpLmVkdYIRZGljZS5taXNzb3VyaS5lZHWCIGRpZ2l0YWxzdG9yeXRlbGxp
419 bmcubWlzc291cmkuZWR1gg9lYS5taXNzb3VyaS5lZHWCG2Vib29rLWRldi5tYXRo
420 Lm1pc3NvdXJpLmVkdYIXZWJvb2suZWNvbi5taXNzb3VyaS5lZHWCGGVuZ2xpc2g4
421 MDA2Lm1pc3NvdXJpLmVkdYIZZXVnZW5lZml0c2NoLm1pc3NvdXJpLmVkdYIYZXVy
422 b2t1bHR1cmUubWlzc291cmkuZWR1ghNmY2RsYWIubWlzc291cmkuZWR1ghZnZW9t
423 dXNldW0ubWlzc291cmkuZWR1ghRoYXJzdGFkLm1pc3NvdXJpLmVkdYITbHVkd2ln
424 Lm1pc3NvdXJpLmVkdYIYbWFjaGluZXNob3AubWlzc291cmkuZWR1ghNtYWpvcnMu
425 bWlzc291cmkuZWR1ghBtZ2EubWlzc291cmkuZWR1ghdvcmdhbnByaW50Lm1pc3Nv
426 dXJpLmVkdYIUcGh5c2ljcy5taXNzb3VyaS5lZHWCFHBtLmNoZW0ubWlzc291cmku
427 ZWR1ghxyZWNydWl0aW5nLmVjb24ubWlzc291cmkuZWR1ghdyZXBlYy5lY29uLm1p
428 c3NvdXJpLmVkdYIUc2NhbmxhYi5taXNzb3VyaS5lZHWCFnNzc2MuY29hcy5taXNz
429 b3VyaS5lZHWCF3RlYWNoLmNvYXMubWlzc291cmkuZWR1ghd0b3B0ZWFjaGVyLm1p
430 c3NvdXJpLmVkdYIQdnNmLm1pc3NvdXJpLmVkdYIid2hpdGVwYXBlci5ncmFkc2No
431 b29sLm1pc3NvdXJpLmVkdTANBgkqhkiG9w0BAQsFAAOCAQEAQutYVAqG7MpmG2Nu
432 Z/UypjYkN4JvwRbKBpTrce2IT/Sy29x6chBbyD+0WE6QORBtaUHuzE1KoXqpnF4M
433 QrkKw0oBAC6x9dISoomq0DkIndtoBYYLaxSoII6F4OGWgF7pQ/7MiCBYzsKQpn9t
434 aofMcTfvnCjq+MCIaeYnUKBVww0lOJlUxZGKxFJvRpf78HfbBauojjRO2zXLZD/u
435 KMspbTfDaj5etIgWGShY2eml3N/SjAENmZYkcgDBYFyi8CckcEBAVzpH1+D+7Anz
436 txHSYDNHAYLv83MwbegApa1FwPqlG/4SdEU8G6e6Xf5GLC/6GPGVTUpr7o348OOO
437 lzGQzw==
438 -----END CERTIFICATE-----
439 -----BEGIN CERTIFICATE-----
440 MIIF+TCCA+GgAwIBAgIQRyDQ+oVGGn4XoWQCkYRjdDANBgkqhkiG9w0BAQwFADCB
441 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
442 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
443 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTQx
444 MDA2MDAwMDAwWhcNMjQxMDA1MjM1OTU5WjB2MQswCQYDVQQGEwJVUzELMAkGA1UE
445 CBMCTUkxEjAQBgNVBAcTCUFubiBBcmJvcjESMBAGA1UEChMJSW50ZXJuZXQyMREw
446 DwYDVQQLEwhJbkNvbW1vbjEfMB0GA1UEAxMWSW5Db21tb24gUlNBIFNlcnZlciBD
447 QTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAJwb8bsvf2MYFVFRVA+e
448 xU5NEFj6MJsXKZDmMwysE1N8VJG06thum4ltuzM+j9INpun5uukNDBqeso7JcC7v
449 HgV9lestjaKpTbOc5/MZNrun8XzmCB5hJ0R6lvSoNNviQsil2zfVtefkQnI/tBPP
450 iwckRR6MkYNGuQmm/BijBgLsNI0yZpUn6uGX6Ns1oytW61fo8BBZ321wDGZq0GTl
451 qKOYMa0dYtX6kuOaQ80tNfvZnjNbRX3EhigsZhLI2w8ZMA0/6fDqSl5AB8f2IHpT
452 eIFken5FahZv9JNYyWL7KSd9oX8hzudPR9aKVuDjZvjs3YncJowZaDuNi+L7RyML
453 fzcCAwEAAaOCAW4wggFqMB8GA1UdIwQYMBaAFFN5v1qqK0rPVIDh2JvAnfKyA2bL
454 MB0GA1UdDgQWBBQeBaN3j2yW4luHS6a0hqxxAAznODAOBgNVHQ8BAf8EBAMCAYYw
455 EgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUH
456 AwIwGwYDVR0gBBQwEjAGBgRVHSAAMAgGBmeBDAECAjBQBgNVHR8ESTBHMEWgQ6BB
457 hj9odHRwOi8vY3JsLnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQ2VydGlmaWNh
458 dGlvbkF1dGhvcml0eS5jcmwwdgYIKwYBBQUHAQEEajBoMD8GCCsGAQUFBzAChjNo
459 dHRwOi8vY3J0LnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQWRkVHJ1c3RDQS5j
460 cnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wDQYJKoZI
461 hvcNAQEMBQADggIBAC0RBjjW29dYaK+qOGcXjeIT16MUJNkGE+vrkS/fT2ctyNMU
462 11ZlUp5uH5gIjppIG8GLWZqjV5vbhvhZQPwZsHURKsISNrqOcooGTie3jVgU0W+0
463 +Wj8mN2knCVANt69F2YrA394gbGAdJ5fOrQmL2pIhDY0jqco74fzYefbZ/VS29fR
464 5jBxu4uj1P+5ZImem4Gbj1e4ZEzVBhmO55GFfBjRidj26h1oFBHZ7heDH1Bjzw72
465 hipu47Gkyfr2NEx3KoCGMLCj3Btx7ASn5Ji8FoU+hCazwOU1VX55mKPU1I2250Lo
466 RCASN18JyfsD5PVldJbtyrmz9gn/TKbRXTr80U2q5JhyvjhLf4lOJo/UzL5WCXED
467 Smyj4jWG3R7Z8TED9xNNCxGBMXnMete+3PvzdhssvbORDwBZByogQ9xL2LUZFI/i
468 eoQp0UM/L8zfP527vWjEzuDN5xwxMnhi+vCToh7J159o5ah29mP+aJnvujbXEnGa
469 nrNxHzu+AGOePV8hwrGGG7hOIcPDQwkuYwzN/xT29iLp/cqf9ZhEtkGcQcIImH3b
470 oJ8ifsCnSbu0GB9L06Yqh7lcyvKDTEADslIaeSEINxhO2Y1fmcYFX/Fqrrp1WnhH
471 OjplXuXE0OPa0utaKC25Aplgom88L2Z8mEWcyfoB7zKOfD759AN7JKZWCYwk
472 -----END CERTIFICATE-----
473 -----BEGIN CERTIFICATE-----
474 MIIF3jCCA8agAwIBAgIQAf1tMPyjylGoG7xkDjUDLTANBgkqhkiG9w0BAQwFADCB
475 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
476 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
477 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTAw
478 MjAxMDAwMDAwWhcNMzgwMTE4MjM1OTU5WjCBiDELMAkGA1UEBhMCVVMxEzARBgNV
479 BAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0plcnNleSBDaXR5MR4wHAYDVQQKExVU
480 aGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNVBAMTJVVTRVJUcnVzdCBSU0EgQ2Vy
481 dGlmaWNhdGlvbiBBdXRob3JpdHkwggIiMA0GCSqGSIb3DQEBAQUAA4ICDwAwggIK
482 AoICAQCAEmUXNg7D2wiz0KxXDXbtzSfTTK1Qg2HiqiBNCS1kCdzOiZ/MPans9s/B
483 3PHTsdZ7NygRK0faOca8Ohm0X6a9fZ2jY0K2dvKpOyuR+OJv0OwWIJAJPuLodMkY
484 tJHUYmTbf6MG8YgYapAiPLz+E/CHFHv25B+O1ORRxhFnRghRy4YUVD+8M/5+bJz/
485 Fp0YvVGONaanZshyZ9shZrHUm3gDwFA66Mzw3LyeTP6vBZY1H1dat//O+T23LLb2
486 VN3I5xI6Ta5MirdcmrS3ID3KfyI0rn47aGYBROcBTkZTmzNg95S+UzeQc0PzMsNT
487 79uq/nROacdrjGCT3sTHDN/hMq7MkztReJVni+49Vv4M0GkPGw/zJSZrM233bkf6
488 c0Plfg6lZrEpfDKEY1WJxA3Bk1QwGROs0303p+tdOmw1XNtB1xLaqUkL39iAigmT
489 Yo61Zs8liM2EuLE/pDkP2QKe6xJMlXzzawWpXhaDzLhn4ugTncxbgtNMs+1b/97l
490 c6wjOy0AvzVVdAlJ2ElYGn+SNuZRkg7zJn0cTRe8yexDJtC/QV9AqURE9JnnV4ee
491 UB9XVKg+/XRjL7FQZQnmWEIuQxpMtPAlR1n6BB6T1CZGSlCBst6+eLf8ZxXhyVeE
492 Hg9j1uliutZfVS7qXMYoCAQlObgOK6nyTJccBz8NUvXt7y+CDwIDAQABo0IwQDAd
493 BgNVHQ4EFgQUU3m/WqorSs9UgOHYm8Cd8rIDZsswDgYDVR0PAQH/BAQDAgEGMA8G
494 A1UdEwEB/wQFMAMBAf8wDQYJKoZIhvcNAQEMBQADggIBAFzUfA3P9wF9QZllDHPF
495 Up/L+M+ZBn8b2kMVn54CVVeWFPFSPCeHlCjtHzoBN6J2/FNQwISbxmtOuowhT6KO
496 VWKR82kV2LyI48SqC/3vqOlLVSoGIG1VeCkZ7l8wXEskEVX/JJpuXior7gtNn3/3
497 ATiUFJVDBwn7YKnuHKsSjKCaXqeYalltiz8I+8jRRa8YFWSQEg9zKC7F4iRO/Fjs
498 8PRF/iKz6y+O0tlFYQXBl2+odnKPi4w2r78NBc5xjeambx9spnFixdjQg3IM8WcR
499 iQycE0xyNN+81XHfqnHd4blsjDwSXWXavVcStkNr/+XeTWYRUc+ZruwXtuhxkYze
500 Sf7dNXGiFSeUHM9h4ya7b6NnJSFd5t0dCy5oGzuCr+yDZ4XUmFF0sbmZgIn/f3gZ
501 XHlKYC6SQK5MNyosycdiyA5d9zZbyuAlJQG03RoHnHcAP9Dc1ew91Pq7P8yF1m9/
502 qS3fuQL39ZeatTXaw2ewh0qpKJ4jjv9cJ2vhsE/zB+4ALtRZh8tSQZXq9EfX7mRB
503 VXyNWQKV3WKdwrnuWih0hKWbt5DHDAff9Yk2dDLWKMGwsAvgnEzDHNb842m1R0aB
504 L6KCq9NjRHDEjf8tM7qtj3u1cIiuPhnPQCjY/MiQu12ZIvVS5ljFH4gxQ+6IHdfG
505 jjxDah2nGN59PRbxYvnKkKj9
506 -----END CERTIFICATE-----
507 EOF
508 cat /etc/ssl/certs/ca-certificates.crt >> $cert
509 CURL_CA_BUNDLE=$cert pi xkbset
510 fi
511
512 ;;&
513 ubuntu|trisquel|debian|fedora)
514 if has_x; then
515 if isdebian-testing; then
516 # xkbset was in testing for quite a while, dunno
517 # why it\'s not anymore. Sometime I should check and
518 # see if it\'s back in testing, but the unstable package
519 # doesn\'t upgrade anything form testing, and it\'s tiny
520 # so I\'m not bothering to automate it.
521 pi xkbset/unstable
522 else
523 pi xkbset
524 fi
525 fi
526 ;;&
527 esac
528
529 if has_x; then
530 pi xbindkeys
531 fi
532 pi cryptsetup lvm2
533 # enables trim for volume delete, other rare commands.
534 sudo $sed -ri 's/( *issue_discards\b).*/\1 = 1/' /etc/lvm/lvm.conf
535
536 if encrypted; then
537 if isdeb; then
538 sudo cp /usr/share/doc/util-linux/examples/fstrim.{service,timer} /etc/systemd/system
539 fi
540 # does weekly trim
541 sudo systemctl enable fstrim.timer
542 fi
543
544 dirs=(/mnt/{1,2,3,4,5,6,7,8,9})
545 s mkdir -p "${dirs[@]}"
546 s chown ian:ian "${dirs[@]}"
547
548
549 tu /etc/fstab <<'EOF'
550 /i/w /w none bind,noauto 0 0
551 /i/k /k none bind,noauto 0 0
552 EOF
553
554
555 if ! mountpoint /kr; then
556 s mkdir -p /kr
557 s chown ian:traci /kr
558 fi
559
560 if home_network; then
561 if [[ $HOSTNAME == treetowl ]]; then
562 tu /etc/fstab <<'EOF'
563 /k /kr none bind,noauto 0 0
564 EOF
565 else
566 tu /etc/fstab <<'EOF'
567 treetowl:/k /kr nfs noauto 0 0
568 EOF
569 fi
570 fi
571
572 s mkdir -p /q /i/{w,k}
573 for dir in /{i,w,k}; do
574 if mountpoint $dir; then continue; fi # already mounted
575 s mkdir -p $dir
576 s chown ian:ian $dir
577 done
578
579 # not needed for all hosts, but rather just keep it uniform
580 s mkdir -p /mnt/iroot
581
582 # debian auto mounting of multi-disk encrypted btrfs is busted. It is
583 # in jessie, and in stretch as of 11/26/2016 I have 4 disks in cryptab,
584 # based on 3 of those, it creates .device units for /dev/mapper/dev...
585 # then waits endlessly for them on bootup, after the /dev/mapper disks
586 # have already been created and exist. todo: create a simple repro
587 # for this in a vm and report it upstream.
588 if has_btrfs || home_network; then
589 pi nfs-common
590 s dd of=/root/imount <<'EOF'
591 #!/bin/bash
592 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
593 set -eE -o pipefail
594 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
595 for dir in /i /mnt/iroot /k /kr /w; do
596 if ! mountpoint $dir &>/dev/null && \
597 awk '{print $2}' /etc/fstab | grep -xF $dir &>/dev/null; then
598 if awk '{print $3}' /etc/fstab | grep -xF nfs &>/dev/null; then
599 mount $dir || echo "warning: failed to mount nfs on $dir"
600 else
601 mount $dir
602 fi
603 fi
604 done
605 EOF
606 s chmod +x /root/imount
607
608 s dd of=/etc/systemd/system/imount.service <<'EOF'
609 [Unit]
610 Description=Mount /i and related mountpoints
611 Before=syncthing@ian.service
612
613 [Service]
614 Type=oneshot
615 ExecStart=/root/imount
616
617 [Install]
618 RequiredBy=syncthing@ian.service
619 # note /kr needs networking, this target is the simplest way to
620 # time it when the network should be up, but not do something
621 # dumb like delay startup until the network is up. It happens
622 # at some time after network.target
623 WantedBy=multi-user.target
624 EOF
625 sudo systemctl daemon-reload # needed if the file was already there
626 sudo systemctl enable imount.service
627 sudo systemctl start imount.service
628 fi
629
630 dir=/nocow
631 if has_btrfs; then
632 if ! mountpoint $dir; then
633 subvol=/mnt/root/nocow
634 if [[ ! -e $subvol ]]; then
635 s btrfs subvolume create $subvol
636 s chown root:1000 $subvol
637 s chattr +C $subvol
638 fi
639
640 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
641 tu /etc/fstab <<EOF
642 $first_root_crypt /nocow btrfs noatime,subvol=nocow 0 0
643 EOF
644 s mkdir -p $dir
645 s chown ian:ian $dir
646 s mount $dir
647 fi
648 else
649 sudo mkdir -p $dir
650 fi
651
652 # ssh and probably some other things care about parent directory
653 # ownership, and ssh doesn\'t allow any group writable parent
654 # directories, so we are forced to use a directory structure similar
655 # to home directories
656 s chown root:ian /q
657 s chmod 755 /q
658
659
660 # it comes with stretch and arch, but not jessie.
661 # propogate /etc/udev/hwdb.d
662 if which systemd-hwdb; then
663 s systemd-hwdb update
664 ser restart systemd-udev-trigger
665 fi
666
667
668 if isdeb; then
669 # I\'ve had problems with postfix on debian:
670 # on stretch, a startup ordering issue caused all mail to fail.
671 # postfix changed defaults to only use ipv6 dns, causing all my mail to fail.
672 # exim4 is default on debian, so I assume it would
673 # be packaged better to avoid these types of things.
674 # I haven\'t gotten around to getting a non-debian exim
675 # setup.
676 mail-setup exim4
677 else
678 mail-setup postfix
679 fi
680
681 if isubuntu; then
682 # disable crash report annoying dialogs.
683 s dd of=/etc/default/apport <<<'enabled=0'
684 fi
685
686 # fai sets this an old way that doesn't work for stretch.
687 # no harm in setting it universally here.
688 # using debconf-set-selection, the area gets reset to ETC
689 # on my linode test machine after doing a dpkg-reconfigure, or a reinstall,
690 # so we are using expect :(
691 # I got a random error when running this, so I added a sleep
692 # rather than trying to write a whole detect and wait loop.
693 # E: Could not get lock /var/lib/dpkg/lock - open (11: Resource temporarily unavailable)
694 # E: Unable to lock the administration directory (/var/lib/dpkg/), is another process using it?
695 sleep 1
696 s apt-get -y install --no-install-recommends expect
697 s expect <<EOF
698 set force_conservative 0
699 spawn dpkg-reconfigure tzdata -freadline
700 expect -nocase timeout {exit 1} "Geographic area:"
701 send "12\r"
702 expect -nocase timeout {exit 1} "Time zone:"
703 send "11\r"
704 expect eof
705 exit
706 EOF
707
708
709 if has_x; then
710 if isarch; then
711 # install so it's build dependencies don't get removed.
712
713 # emacs git build is currently broken
714 if false; then
715 x=$(mktemp -d)
716 pushd $x
717 aurex emacs-git
718 makepkg -si --noconfirm
719 popd
720 rm -rf $x
721 else
722 pi emacs
723 fi
724 pi hunspell hunspell-en
725 else
726 if $recompile; then
727 /a/bin/buildscripts/emacs
728 else
729 /a/bin/buildscripts/emacs --no-r || /a/bin/buildscripts/emacs
730 fi
731 fi
732
733 # todo, figure this out for arch if we ever try out gnome.
734 if ! isarch; then
735 # install for multiple display managers in case we use one
736 if isdeb; then
737 dir=/etc/gdm3
738 elif isfedora; then
739 # fedora didn\'t have the 3.
740 dir=/etc/gdm
741 fi
742 s mkdir -p $dir/PostLogin
743 s command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
744 s mkdir /etc/lightdm/lightdm.conf.d
745 s dd of=/etc/lightdm/lightdm.conf.d/12-ian.conf <<'EOF'
746 [SeatDefaults]
747 session-setup-script=/a/bin/distro-setup/desktop-20-autostart.sh
748 EOF
749 fi
750
751
752 pi ghc sakura
753 # todo, also note for work comp, scp opt/org-mode bin/build-scripts
754
755 # use the package manger version to install the cabal version
756 pi cabal-install
757 cabal update
758 PATH="$PATH:$HOME/.cabal/bin"
759
760 # todo, on older ubuntu I used cabal xmonad + xfce,
761 # see /a/bin/old-unused/xmonad-cabal.sh
762
763 # trying out the distros versions newer distros
764 pi xmonad
765 if isarch; then
766 # for displaying error messages.
767 # optional dependency in arch, standard elsewhere.
768 pi xorg-xmessage xmonad-contrib xorg-xsetroot xorg-xinit
769
770 # https://wiki.archlinux.org/index.php/Xinitrc
771 for homedir in /home/*; do
772 cp /etc/X11/xinit/xinitrc $homedir/.xinitrc
773 $sed -ri '/^ *twm\b/,$d' $homedir/.xinitrc
774 tee -a $homedir/.xinitrc <<'EOF'
775 /a/bin/desktop-20-autostart.sh
776 xsetroot -cursor_name left_ptr
777 exec xmonad
778 EOF
779 done
780 else
781 pi suckless-tools
782 fi
783 pi dmenu
784
785 if tp || x2; then
786 case $distro in
787 debian)
788 pi task-laptop
789 ;;
790 ubuntu|trisquel)
791 # the exact packages that task-laptop would install, since ubuntu
792 # doesn\'t have this virtual in practice package.
793 pi avahi-autoipd bluetooth powertop iw wireless-tools wpasupplicant
794 ;;
795 # todo: other distros unknown
796 esac
797 fi
798 fi
799
800 # the first pup command can kill off our /etc/ mod, so rerun this
801 /a/exe/ssh-emacs-setup
802 echo "$0: $(date): ending now"